unit BeerGCls;

interface

uses
  Windows , Messages , Classes , Dialogs , ScktComp , SysUtils;

type
 // v[[^Cv(XA񎟉XAꎟXAH4^Cv)
  TPlayerType   = (PT_UnKnown , PT_Factory , PT_Whole1  , PT_Whole2 , PT_Retail);
  TPlayOwner    = (PO_UnKnown , PO_Client  , PO_Server  , PO_Auto);
  TShipmentType = (ST_Unknown , ST_All     , ST_Manual  , ST_Auto);
  TGameStatus   = (GS_UnKnown , GS_Prepare , GS_Playing , GS_Pause  , GS_Over);

 // ڑv[[֘A(Socket.DataɂĊi[)
  TPlayerData = packed record
    Certified    : Boolean;         // ڑF߂Ă邩 = NCAgXgɂ̂邩
    NowJoinIn    : Boolean;         // LFĂ邩
    PlayerName   : String;
    PlayerType   : TPlayerType;     // S
    PlayOwner    : TPlayOwner;      // 삷̂ClientAServer(Manual)AAutôǂꂩ
    ShipmentType : TShipmentType;   // zőSĂ蓮
    NowOrder     : ShortInt;        // ̃^[̔(O-1)
    NowShipment  : ShortInt;        // ̃^[̔z(-1Ɩ)
    ConnectTime  : TDateTime;
    Socket       : TCustomWinSocket;
  end;
  PPlayerData = ^TPlayerData;

 // Q[NX
  TBeerGame = class(TPersistent)
  private
    FDbg          : Boolean;
    FParentHandle : THandle;
    FNowTurn      : ShortInt;
    FFinalTurn    : ShortInt;
 // FNowPlaying   : Boolean;
    FGameStatus   : TGameStatus; // Q[
    FStockCost    : Currency;  // ݌ɔpv
    FBackLogCost  : Currency;  // 󒍎cpv
    FTotalCost    : Currency;  // pv
    FFt_Ave_Stk   : Currency;  // ύ݌ɐ
    FFt_Ave_BLC   : Currency;  // ώ󒍎c
    FW1_Ave_Stk   : Currency;
    FW1_Ave_BLC   : Currency;
    FW2_Ave_Stk   : Currency;
    FW2_Ave_BLC   : Currency;
    FRt_Ave_Stk   : Currency;
    FRt_Ave_BLC   : Currency;
    procedure SetFinalTurn(FinalTurn : ShortInt);
    procedure SendClientStatus();
    procedure CountResult(const CountTurn : ShortInt);
  public
    GroupName     : String;       // `[
    GrpName       : String;
    FactoryPlayer : PPlayerData;  // v[܂PClientData(Socket.Data)
    Whole1Player  : PPlayerData;
    Whole2Player  : PPlayerData;
    RetailPlayer  : PPlayerData;
    Factory_AutoP : TPlayerData;
    Whole1_AutoP  : TPlayerData;
    Whole2_AutoP  : TPlayerData;
    Retail_AutoP  : TPlayerData;
  // ݌
    Material_Lt1 : array of Byte; // Yx1
    Material_Lt2 : array of Byte; // Yx2
    Factory_Stk  : array of Byte; // H݌
    Factory_BLC  : array of Byte; // H󒍎c
    Factory_Lt1  : array of Byte; // zx1(H)
    Factory_Lt2  : array of Byte; // zx2(H)
    Whole1_Stk   : array of Byte; // ꎟ݌
    Whole1_BLC   : array of Byte; // ꎟ󒍎c
    Whole1_Lt1   : array of Byte; // zx1(ꎟ)
    Whole1_Lt2   : array of Byte; // zx2(ꎟ)
    Whole2_Stk   : array of Byte; // 񎟉݌
    Whole2_BLC   : array of Byte; // 񎟉󒍎c
    Whole2_Lt1   : array of Byte; // zx1(񎟉)
    Whole2_Lt2   : array of Byte; // zx2(񎟉)
    Retail_Stk   : array of Byte; // X݌
    Retail_BLC   : array of Byte; // X󒍎c
   // 
    Retail_Ord1 : array of Byte;  // X񎟉ւ̔
    Retail_Ord2 : array of Byte;  // X񎟉ւ̒
    Whole2_Ord1 : array of Byte;  // 񎟉ꎟւ̔
    Whole2_Ord2 : array of Byte;  // 񎟉ꎟւ̒
    Whole1_Ord1 : array of Byte;  // ꎟHւ̔
    Whole1_Ord2 : array of Byte;  // ꎟHւ̒
    Factory_Ord : array of Byte;  // Hꂩ猴ޗւ̐Yv
   // sv̔
    Marcket_Ord : array of Byte;  // sꂩ珬Xւ̒[
    Marcket_Sld : array of Byte;  // s֔̔
   // RXg
    UStockCost   : Currency;
    UBackLogCost : Currency;
    StockCosts   : array of Currency;
    BackLogCosts : array of Currency;
    TotalCosts   : array of Currency;
    constructor Create        (ParentHandle : THandle);
    destructor  Destroy       (); override;
    procedure   Initialize    ();
    procedure   LoadDefDemand (Value : Byte = 4);
    procedure   LoadDefFirst  ();
    procedure   RandomDemand  (Min , Max : Byte);
    procedure   RandomInit    (Min , Max : Byte);
    procedure   Start         ();
    procedure   Pause         ();
    procedure   ProcessTurn   ();
    procedure   Assign        (Source : TPersistent);  override;
    procedure   LoadFromFile  (const FilePath : String);
    procedure   LoadFromStream(Stream : TStream);
    procedure   SaveToFile    (const FilePath : String);
    procedure   SaveToStream  (Stream : TStream);
    procedure   SendText      (const Socket : TCustomWinSocket; const SendText : String; const UnitLength : Byte = 10; const DivChar : Char = #9);
    function    CheckInput    () : ShortInt;
    function    CanStart      () : Boolean;
    function    CanEntry      (const PlayerType : TPlayerType) : Boolean;
    function    CanOrder      (const PlayerType : TPlayerType) : Boolean;
    function    EnDeCrypt     (const Value : String) : String;
    function    ResultMessage () : String;
    property    NowTurn    : ShortInt    read FNowTurn   write FNowTurn;
//  property    NowTurn    : ShortInt    read FNowTurn;
    property    FinalTurn  : ShortInt    read FFinalTurn write SetFinalTurn;
//  property    NowPlaying : Boolean     read FNowPlaying;
//  property    GameStatus : TGameStatus read FGameStatus;
    property    GameStatus : TGameStatus read FGameStatus write FGameStatus;
  end;

const
  WM_InputCheck   = WM_USER + 187;
  SrcDivChar      = #9;  // {͐^u
 // Grid Index
  GI_Turn         = 0;  // T
 // Ԃ(Ă钍A͂i2A݌ɁA钍̏)
  GI_Factory      = 1;  // H^Cg
  GI_Material_Lt1 = 2;  // Yx1
  GI_Material_Lt2 = 3;  // Yx2
  GI_Factory_Stk  = 4;  // H݌
  GI_Whole1_Ord2  = 5;  // ꎟ
  GI_Factory_BLC  = 6;  // H󒍎c
  GI_Factory_Lt1  = 7;  // Hzx1
  GI_Factory_Ord  = 8;  // Yv
  GI_Space1       = 9;
  GI_Whole1       = 10; // ꎟ^Cg
  GI_Factory_Lt2  = 11; // Hzx2
  GI_Whole1_Stk   = 12; // ꎟ݌
  GI_Whole2_Ord2  = 13; // 񎟉
  GI_Whole1_BLC   = 14; // ꎟ󒍎c
  GI_Whole1_Lt1   = 15; // ꎟzx1
  GI_Whole1_Ord1  = 16; // ꎟ
  GI_Space2       = 17;
  GI_Whole2       = 18; // 񎟉^Cg
  GI_Whole1_Lt2   = 19; // ꎟzx2
  GI_Whole2_Stk   = 20; // 񎟉݌
  GI_Retail_Ord2  = 21; // X
  GI_Whole2_BLC   = 22; // 񎟉󒍎c
  GI_Whole2_Lt1   = 23; // 񎟉zx1
  GI_Whole2_Ord1  = 24; // 񎟉
  GI_Space3       = 25;
  GI_Retail       = 26; // X^Cg
  GI_Whole2_Lt2   = 27; // 񎟉zx2
  GI_Retail_Stk   = 28; // X݌
  GI_Marcket_Ord  = 29; // sv
  GI_Retail_BLC   = 30; // X󒍎c
  GI_Marcket_Sld  = 31; // s֔̔
  GI_Retail_Ord1  = 32; // X
  GI_Space4       = 33;
  GI_Cost         = 34; // RXg^Cg
  GI_StockCost    = 35; // ݌ɔp;
  GI_BackLogCost  = 36; // 󒍎cp;
  GI_TotalCost    = 37; // vp;

implementation

//------------------------------------------------------------------------------
//---------------------------- RXgN^ ----------------------------------
constructor TBeerGame.Create(ParentHandle : THandle);
begin
  FDbg          := False;
  FParentHandle := ParentHandle;
  FFinalTurn    := 30;
  FNowTurn      := 0;
  FGameStatus   := GS_Prepare;
  UStockCost    := 0.5;
  UBackLogCost  := 1;
  FStockCost    := 0;
  FBackLogCost  := 0;
  FTotalCost    := 0;
  FFt_Ave_Stk   := 0;
  FFt_Ave_BLC   := 0;
  FW1_Ave_Stk   := 0;
  FW1_Ave_BLC   := 0;
  FW2_Ave_Stk   := 0;
  FW2_Ave_BLC   := 0;
  FRt_Ave_Stk   := 0;
  FRt_Ave_BLC   := 0;
  Initialize();
end;

//------------------------------------------------------------------------------
//----------------------------- fXNgN^ ---------------------------------
destructor TBeerGame.Destroy();
begin
  FFinalTurn := 1;
  Initialize();
  inherited;
end;

//------------------------------------------------------------------------------
function TBeerGame.CanStart() : Boolean;
begin
  Result := False;
 // S`FbN
  if      ((FactoryPlayer = Nil) or (FactoryPlayer^.PlayerType <> PT_Factory)) then Exit
  else if ((Whole1Player  = Nil) or (Whole1Player^.PlayerType  <> PT_Whole1))  then Exit
  else if ((Whole2Player  = Nil) or (Whole2Player^.PlayerType  <> PT_Whole2))  then Exit
  else if ((RetailPlayer  = Nil) or (RetailPlayer^.PlayerType  <> PT_Retail))  then Exit;
 // SQĂ邩
  if      (not FactoryPlayer^.NowJoinIn) then Exit
  else if (not Whole1Player^.NowJoinIn)  then Exit
  else if (not Whole2Player^.NowJoinIn)  then Exit
  else if (not RetailPlayer^.NowJoinIn)  then Exit;
 // S삷l炩ȂOK
  if      ((FactoryPlayer^.PlayOwner    = PO_UnKnown))  then Exit
  else if ((Whole1Player^.PlayOwner     = PO_UnKnown))  then Exit
  else if ((Whole2Player^.PlayOwner     = PO_UnKnown))  then Exit
  else if ((RetailPlayer^.PlayOwner     = PO_UnKnown))  then Exit;
 // NCAg̏ꍇŃ\Pbgs̏ꍇ͂悤Ȃ
  if ((FactoryPlayer^.PlayOwner = PO_Client) and (FactoryPlayer^.Socket = Nil)) then Exit;
  if ((Whole1Player^.PlayOwner  = PO_Client) and (Whole1Player^.Socket  = Nil)) then Exit;
  if ((Whole2Player^.PlayOwner  = PO_Client) and (Whole2Player^.Socket  = Nil)) then Exit;
  if ((RetailPlayer^.PlayOwner  = PO_Client) and (RetailPlayer^.Socket  = Nil)) then Exit;
{
 // \Pbgs̏ꍇ͂悤Ȃ
  if (FactoryPlayer^.Socket = Nil) then Exit;
  if (Whole1Player^.Socket  = Nil) then Exit;
  if (Whole2Player^.Socket  = Nil) then Exit;
  if (RetailPlayer^.Socket  = Nil) then Exit;
}
 // Szw^Cv炩ȂOK
  if      ((FactoryPlayer^.ShipmentType = ST_UnKnown))  then Exit
  else if ((Whole1Player^.ShipmentType  = ST_UnKnown))  then Exit
  else if ((Whole2Player^.ShipmentType  = ST_UnKnown))  then Exit
  else if ((RetailPlayer^.ShipmentType  = ST_UnKnown))  then Exit;
 // AutoȂ̂ɔzManual̏ꍇ͂悤Ȃ
  if      ((FactoryPlayer^.PlayOwner = PO_Auto) and (FactoryPlayer^.ShipmentType = ST_Manual)) then Exit
  else if ((Whole1Player^.PlayOwner = PO_Auto)  and (Whole1Player^.ShipmentType  = ST_Manual)) then Exit
  else if ((Whole2Player^.PlayOwner = PO_Auto)  and (Whole2Player^.ShipmentType  = ST_Manual)) then Exit
  else if ((RetailPlayer^.PlayOwner = PO_Auto)  and (RetailPlayer^.ShipmentType  = ST_Manual)) then Exit;
  Result := True;
//if ((FGameStatus = GS_Prepare) or (FGameStatus = GS_Pause) or (FGameStatus = GS_Over) then
  if  (FGameStatus = GS_Playing) then Result := False;
end;

//------------------------------------------------------------------------------
//------------------------ Qo^tǂH ----------------------------
function TBeerGame.CanEntry(const PlayerType : TPlayerType) : Boolean;
begin
  case (PlayerType) of
    PT_Factory : Result := ((FactoryPlayer = Nil) or (FactoryPlayer^.PlayOwner = PO_UnKnown));
    PT_Whole1  : Result := ((Whole1Player  = Nil) or (Whole1Player^.PlayOwner = PO_UnKnown));
    PT_Whole2  : Result := ((Whole2Player  = Nil) or (Whole2Player^.PlayOwner = PO_UnKnown));
    PT_Retail  : Result := ((RetailPlayer  = Nil) or (RetailPlayer^.PlayOwner = PO_UnKnown));
    else         Result := False;
  end;
//if (Result) then  ShowMessage('Nil')
//else              ShowMessage('Exist');
end;

//------------------------------------------------------------------------------
//------------- T[ȍꍇÃ^[̓͂܂ǂH -------------
function TBeerGame.CanOrder(const PlayerType : TPlayerType) : Boolean;
begin
  Result := False;
  case (PlayerType) of
    PT_Factory :
    begin
      if (FactoryPlayer = Nil) then Exit;
      Result := ((FGameStatus = GS_Playing) and (FactoryPlayer^.PlayOwner = PO_Server) and (FactoryPlayer^.NowOrder < 0));
    end;
    PT_Whole1  :
    begin
      if (Whole1Player = Nil) then Exit;
      Result := ((FGameStatus = GS_Playing) and (Whole1Player^.PlayOwner = PO_Server) and (Whole1Player^.NowOrder < 0));
    end;
    PT_Whole2  :
    begin
      if (Whole2Player = Nil) then Exit;
      Result := ((FGameStatus = GS_Playing) and (Whole2Player^.PlayOwner = PO_Server) and (Whole2Player^.NowOrder < 0));
    end;
    PT_Retail  :
    begin
      if (RetailPlayer = Nil) then Exit;
      Result := ((FGameStatus = GS_Playing) and (RetailPlayer^.PlayOwner = PO_Server) and (RetailPlayer^.NowOrder < 0));
    end;
  end;
end;

//------------------------------------------------------------------------------
//---------------------- Q[̑^[w(&zm) ---------------------
procedure TBeerGame.SetFinalTurn(FinalTurn : ShortInt);
begin
  if  (FFinalTurn < 1) then Exit;
 // vCɌ݃^[I^[Oɂꍇ
  if ((FGameStatus = GS_Playing) and (FinalTurn < FNowTurn)) then FinalTurn := FNowTurn;
  FFinalTurn := FinalTurn;
//
  SetLength(Material_Lt1 , FFinalTurn);
  SetLength(Material_Lt2 , FFinalTurn);
  SetLength(Factory_Stk  , FFinalTurn);
  SetLength(Factory_BLC  , FFinalTurn);
  SetLength(Factory_Lt1  , FFinalTurn);
  SetLength(Factory_Lt2  , FFinalTurn);
  SetLength(Whole1_Stk   , FFinalTurn);
  SetLength(Whole1_BLC   , FFinalTurn);
  SetLength(Whole1_Lt1   , FFinalTurn);
  SetLength(Whole1_Lt2   , FFinalTurn);
  SetLength(Whole2_Stk   , FFinalTurn);
  SetLength(Whole2_BLC   , FFinalTurn);
  SetLength(Whole2_Lt1   , FFinalTurn);
  SetLength(Whole2_Lt2   , FFinalTurn);
  SetLength(Retail_Stk   , FFinalTurn);
  SetLength(Retail_BLC   , FFinalTurn);
 // 
  SetLength(Retail_Ord1  , FFinalTurn);
  SetLength(Retail_Ord2  , FFinalTurn);
  SetLength(Whole2_Ord1  , FFinalTurn);
  SetLength(Whole2_Ord2  , FFinalTurn);
  SetLength(Whole1_Ord1  , FFinalTurn);
  SetLength(Whole1_Ord2  , FFinalTurn);
  SetLength(Factory_Ord  , FFinalTurn);
 // sv
  SetLength(Marcket_Ord  , FFinalTurn);
  SetLength(Marcket_Sld  , FFinalTurn);
 // RXg
  SetLength(StockCosts   , FFinalTurn);
  SetLength(BackLogCosts , FFinalTurn);
  SetLength(TotalCosts   , FFinalTurn);
end;

//------------------------------------------------------------------------------
//-------------------------- `[̃f[^ ------------------------------
procedure TBeerGame.Initialize();
begin
 // ^[ύXŃQ[f[^zm
  FNowTurn   := 0;
  GameStatus := GS_Prepare;
  SetFinalTurn(FFinalTurn);
 // (Ƃ肠0)
  ZeroMemory(Material_Lt1 , Length(Material_Lt1));
  ZeroMemory(Material_Lt2 , Length(Material_Lt2));
  ZeroMemory(Factory_Stk  , Length(Factory_Stk));
  ZeroMemory(Factory_BLC  , Length(Factory_BLC));
  ZeroMemory(Factory_Lt1  , Length(Factory_Lt1));
  ZeroMemory(Factory_Lt2  , Length(Factory_Lt2));
  ZeroMemory(Whole1_Stk   , Length(Whole1_Stk));
  ZeroMemory(Whole1_BLC   , Length(Whole1_BLC));
  ZeroMemory(Whole1_Lt1   , Length(Whole1_Lt1));
  ZeroMemory(Whole1_Lt2   , Length(Whole1_Lt2));
  ZeroMemory(Whole2_Stk   , Length(Whole2_Stk));
  ZeroMemory(Whole2_BLC   , Length(Whole2_BLC));
  ZeroMemory(Whole2_Lt1   , Length(Whole2_Lt1));
  ZeroMemory(Whole2_Lt2   , Length(Whole2_Lt2));
  ZeroMemory(Retail_Stk   , Length(Retail_Stk));
  ZeroMemory(Retail_BLC   , Length(Retail_BLC));
  ZeroMemory(Retail_Ord1  , Length(Retail_Ord1));
  ZeroMemory(Retail_Ord2  , Length(Retail_Ord2));
  ZeroMemory(Whole2_Ord1  , Length(Whole2_Ord1));
  ZeroMemory(Whole2_Ord2  , Length(Whole2_Ord2));
  ZeroMemory(Whole1_Ord1  , Length(Whole1_Ord1));
  ZeroMemory(Whole1_Ord2  , Length(Whole1_Ord2));
  ZeroMemory(Factory_Ord  , Length(Factory_Ord));
  ZeroMemory(Marcket_Ord  , Length(Marcket_Ord));
  ZeroMemory(Marcket_Sld  , Length(Marcket_Sld));
  ZeroMemory(StockCosts   , Length(StockCosts));
  ZeroMemory(BackLogCosts , Length(BackLogCosts));
  ZeroMemory(TotalCosts   , Length(TotalCosts));
 // Kl[h
  LoadDefFirst();
  LoadDefDemand();
 // AIf[^
//
  Factory_AutoP.Certified    := False;
  Factory_AutoP.ConnectTime  := Now();
  Factory_AutoP.NowJoinIn    := True;
  Factory_AutoP.PlayOwner    := PO_UnKnown;
  Factory_AutoP.PlayerName   := 'Factory(server operation)';
  Factory_AutoP.PlayerType   := PT_Factory;
  Factory_AutoP.ShipmentType := ST_UnKnown;
  Factory_AutoP.NowOrder     := -1;
  Factory_AutoP.NowShipment  := -1;
  Factory_AutoP.Socket       := Nil;
  Whole1_AutoP.Certified     := False;
  Whole1_AutoP.ConnectTime   := Now();
  Whole1_AutoP.NowJoinIn     := True;
  Whole1_AutoP.PlayOwner     := PO_UnKnown;
  Whole1_AutoP.PlayerName    := 'Distributor(server operation)';
  Whole1_AutoP.PlayerType    := PT_Whole1;
  Whole1_AutoP.ShipmentType  := ST_UnKnown;
  Whole1_AutoP.NowOrder      := -1;
  Whole1_AutoP.NowShipment   := -1;
  Whole1_AutoP.Socket        := Nil;
  Whole2_AutoP.Certified     := False;
  Whole2_AutoP.ConnectTime   := Now();
  Whole2_AutoP.NowJoinIn     := True;
  Whole2_AutoP.PlayOwner     := PO_UnKnown;
  Whole2_AutoP.PlayerName    := 'Wholesaler(server operation)';
  Whole2_AutoP.PlayerType    := PT_Whole2;
  Whole2_AutoP.ShipmentType  := ST_UnKnown;
  Whole2_AutoP.NowOrder      := -1;
  Whole2_AutoP.NowShipment   := -1;
  Whole2_AutoP.Socket        := Nil;
  Retail_AutoP.Certified     := False;
  Retail_AutoP.ConnectTime   := Now();
  Retail_AutoP.NowJoinIn     := True;
  Retail_AutoP.PlayOwner     := PO_UnKnown;
  Retail_AutoP.PlayerName    := 'Retailer(server operation)';
  Retail_AutoP.PlayerType    := PT_Retail;
  Retail_AutoP.ShipmentType  := ST_UnKnown;
  Retail_AutoP.NowOrder      := -1;
  Retail_AutoP.NowShipment   := -1;
  Retail_AutoP.Socket        := Nil;
end;


//--------------------------- l̋Kl -----------------------
procedure TBeerGame.LoadDefFirst();
begin
//Material_Stk[0] := 4;  // ޗ̓^[|Ȃ炵H
  Material_Lt1[0] := 4;  // Yx1̏l
  Material_Lt2[0] := 4;  // Yx2̏l
  Factory_Stk[0]  := 12; // H݌ɂ̏l
  Factory_BLC[0]  := 0;  // H󒍎c̏l
  Factory_Lt1[0]  := 4;  // zx1(H)̏l
  Factory_Lt2[0]  := 4;  // zx2(H)̏l
  Whole1_Stk[0]   := 12; // ꎟ݌ɂ̏l
  Whole1_BLC[0]   := 0;  // ꎟ󒍎c̏l
  Whole1_Lt1[0]   := 4;  // zx1(ꎟ)̏l
  Whole1_Lt2[0]   := 4;  // zx2(ꎟ)̏l
  Whole2_Stk[0]   := 12; // 񎟉݌ɂ̏l
  Whole2_BLC[0]   := 0;  // 񎟉󒍎c̏l
  Whole2_Lt1[0]   := 4;  // zx1(񎟉)̏l
  Whole2_Lt2[0]   := 4;  // zx2(񎟉)̏l
  Retail_Stk[0]   := 12; // X݌ɂ̏l
  Retail_BLC[0]   := 0;  // X󒍎c̏l
  Retail_Ord1[0]  := 4;  // X񎟉ւ̔̏l
  Retail_Ord2[0]  := 4;  // X񎟉ւ̒̏l
  Whole2_Ord1[0]  := 4;  // 񎟉ꎟւ̔̏l
  Whole2_Ord2[0]  := 4;  // 񎟉ꎟւ̒̏l
  Whole1_Ord1[0]  := 4;  // ꎟHւ̔̏l
  Whole1_Ord2[0]  := 4;  // ꎟHւ̒̏l
  Factory_Ord[0]  := 4;  // Hꂩ猴ޗւ̐Yv̏l
end;

//------------------------------------------------------------------------------
//----------------------------- sv̋Kl -------------------------------
procedure TBeerGame.LoadDefDemand(Value : Byte);
 var
  i : Integer;
//-----------------4Tڂ܂ł4ɁAȍ~8ɁB05/07/21---
begin
  for i := 0 to 4 do
    Marcket_Ord[i] := Value;

  for i := 5 to High(Marcket_Ord) do
    Marcket_Ord[i] := 8;
end;

//------------------------------------------------------------------------------
//----------------------------- sv_ -------------------------------
procedure TBeerGame.RandomDemand(Min , Max : Byte);
 var
  Dif : Byte;
  i   : Integer;
begin
  if (Length(Marcket_Ord) < 1) then Exit;
  if (Max < Min) then Max := Min;
 // MaxMinɍȂΑS
  if (Max = Min) then
  begin
    for i := 0 to High(Marcket_Ord) do
      Marcket_Ord[i] := Max;
  end
 // Max > MinȂ烉_
  else
  begin
    Dif := Max - Min;
    for i := 0 to High(Marcket_Ord) do
      Marcket_Ord[i] := Min + Random(Dif);
  end;
end;

//------------------------------------------------------------------------------
//------------------------------ l_ --------------------------------
procedure TBeerGame.RandomInit(Min , Max : Byte);
 var
  Dif : Byte;
begin
  if (FinalTurn < 1) then Exit;
  if (Max < Min) then Max := Min;
  Dif := Max - Min;
 // MaxMinɍȂΑS
  if (Max = Min) then
  begin
    Material_Lt1[0] := Max;
    Material_Lt2[0] := Max;
    Factory_Stk[0]  := Max;
    Factory_BLC[0]  := Max;
    Factory_Lt1[0]  := Max;
    Factory_Lt2[0]  := Max;
    Whole1_Stk[0]   := Max;
    Whole1_BLC[0]   := Max;
    Whole1_Lt1[0]   := Max;
    Whole1_Lt2[0]   := Max;
    Whole2_Stk[0]   := Max;
    Whole2_BLC[0]   := Max;
    Whole2_Lt1[0]   := Max;
    Whole2_Lt2[0]   := Max;
    Retail_Stk[0]   := Max;
    Retail_BLC[0]   := Max;
    Retail_Ord1[0]  := Max;
    Retail_Ord2[0]  := Max;
    Whole2_Ord1[0]  := Max;
    Whole2_Ord2[0]  := Max;
    Whole1_Ord1[0]  := Max;
    Whole1_Ord2[0]  := Max;
    Factory_Ord[0]  := Max;
  end
 // Max > MinȂ烉_
  else
  begin
    Material_Lt1[0] := Min + Random(Dif);
    Material_Lt2[0] := Min + Random(Dif);
    Factory_Stk[0]  := Min + Random(Dif);
    Factory_BLC[0]  := Min + Random(Dif);
    Factory_Lt1[0]  := Min + Random(Dif);
    Factory_Lt2[0]  := Min + Random(Dif);
    Whole1_Stk[0]   := Min + Random(Dif);
    Whole1_BLC[0]   := Min + Random(Dif);
    Whole1_Lt1[0]   := Min + Random(Dif);
    Whole1_Lt2[0]   := Min + Random(Dif);
    Whole2_Stk[0]   := Min + Random(Dif);
    Whole2_BLC[0]   := Min + Random(Dif);
    Whole2_Lt1[0]   := Min + Random(Dif);
    Whole2_Lt2[0]   := Min + Random(Dif);
    Retail_Stk[0]   := Min + Random(Dif);
    Retail_BLC[0]   := Min + Random(Dif);
    Retail_Ord1[0]  := Min + Random(Dif);
    Retail_Ord2[0]  := Min + Random(Dif);
    Whole2_Ord1[0]  := Min + Random(Dif);
    Whole2_Ord2[0]  := Min + Random(Dif);
    Whole1_Ord1[0]  := Min + Random(Dif);
    Whole1_Ord2[0]  := Min + Random(Dif);
    Factory_Ord[0]  := Min + Random(Dif);
  end;
end;

//------------------------------------------------------------------------------
//----------------------------- Q[Jn/ĊJ --------------------------------
procedure TBeerGame.Start();
 const
  StartMsg   = 'BS_Gm:Start!';
  ReStartMsg = 'BS_Gm:ReStart!';
begin
  if (not CanStart()) then Exit;

 // Q[ĨQ[X^[g̓^[߂
  if (FGameStatus = GS_Over) then
  begin
    FNowTurn   := 0;
    GameStatus := GS_Prepare;
    SetFinalTurn(FFinalTurn);
  end;

  if (FGameStatus = GS_Prepare) then
  begin // 0^[ڂ̃RXgvZ -----StockCosts  [NowTurn]   / 2  폜UStockCostZBBLCUBackLogCostZB@05/07/21-----@
    StockCosts  [NowTurn] := (Factory_Stk[NowTurn] + Whole1_Stk  [NowTurn] + Whole2_Stk[NowTurn] + Retail_Stk[NowTurn]) * UStockCost;
    BackLogCosts[NowTurn] := (Factory_BLC[NowTurn] + Whole1_BLC  [NowTurn] + Whole2_BLC[NowTurn] + Retail_BLC[NowTurn]) * UBackLogCost;
    TotalCosts  [NowTurn] :=  StockCosts [NowTurn] + BackLogCosts[NowTurn];
   // 肪NCAgȂQ[JnbZ[WM
    if (FactoryPlayer^.PlayOwner = PO_Client) then FactoryPlayer^.Socket.SendText(StartMsg + SrcDivChar);
    if (Whole1Player^.PlayOwner  = PO_Client) then Whole1Player^.Socket.SendText (StartMsg + SrcDivChar);
    if (Whole2Player^.PlayOwner  = PO_Client) then Whole2Player^.Socket.SendText (StartMsg + SrcDivChar);
    if (RetailPlayer^.PlayOwner  = PO_Client) then RetailPlayer^.Socket.SendText (StartMsg + SrcDivChar);
   // ^[1₷
    Inc(FNowTurn);
  end
  else if ((FGameStatus = GS_Pause) or (FGameStatus = GS_Over)) then
  begin
   // 肪NCAgȂQ[ĊJbZ[WM
    if (FactoryPlayer^.PlayOwner = PO_Client) then FactoryPlayer^.Socket.SendText(ReStartMsg + SrcDivChar);
    if (Whole1Player^.PlayOwner  = PO_Client) then Whole1Player^.Socket.SendText (ReStartMsg + SrcDivChar);
    if (Whole2Player^.PlayOwner  = PO_Client) then Whole2Player^.Socket.SendText (ReStartMsg + SrcDivChar);
    if (RetailPlayer^.PlayOwner  = PO_Client) then RetailPlayer^.Socket.SendText (ReStartMsg + SrcDivChar);
  end;
  Beep();
  FGameStatus := GS_Playing;
 // 肪NCAgڑȂŏ̃bZ[WM
  SendClientStatus();
end;

//------------------------------------------------------------------------------
//------------------------------- Q[~ -----------------------------------
procedure TBeerGame.Pause();
begin
  if      (FGameStatus <> GS_Playing) then Exit
  else if (FNowTurn >= FFinalTurn)    then FGameStatus := GS_Over
  else                                     FGameStatus := GS_Pause;
  Beep();
end;

//------------------------------------------------------------------------------
//-- SL͊Ȃ0A܂Ȃ-1AQ[I1Ԃ1^[i߂ ---
function TBeerGame.CheckInput() : ShortInt;
begin
  Result := -1;
  if (FGameStatus <> GS_Playing) then Exit;
  if (FactoryPlayer = Nil) then Exit;
  if (Whole1Player  = Nil) then Exit;
  if (Whole2Player  = Nil) then Exit;
  if (RetailPlayer  = Nil) then Exit;
//ShowMessage('10');
 // s̏ꍇ͂悤Ȃ
  if (FactoryPlayer^.PlayOwner = PO_UnKnown) then Exit;
  if (Whole1Player^.PlayOwner  = PO_UnKnown) then Exit;
  if (Whole2Player^.PlayOwner  = PO_UnKnown) then Exit;
  if (RetailPlayer^.PlayOwner  = PO_UnKnown) then Exit;
//ShowMessage('20');
 // zwߕs̏ꍇ͂悤Ȃ
  if  (FactoryPlayer^.ShipmentType = ST_UnKnown) then Exit;
  if  (Whole1Player^.ShipmentType  = ST_UnKnown) then Exit;
  if  (Whole2Player^.ShipmentType  = ST_UnKnown) then Exit;
  if  (RetailPlayer^.ShipmentType  = ST_UnKnown) then Exit;
//ShowMessage('30');
 // Sw߂łĂʂ(I[g̏ꍇ)
  if ((FactoryPlayer^.PlayOwner <> PO_Auto) and (FactoryPlayer^.NowOrder < 0)) then Exit;
  if ((Whole1Player^.PlayOwner  <> PO_Auto) and (Whole1Player^.NowOrder  < 0)) then Exit;
  if ((Whole2Player^.PlayOwner  <> PO_Auto) and (Whole2Player^.NowOrder  < 0)) then Exit;
  if ((RetailPlayer^.PlayOwner  <> PO_Auto) and (RetailPlayer^.NowOrder  < 0)) then Exit;
//ShowMessage('40');
 // Szw߂łĂʂ(}jAw̏ꍇ̂)
  if ((FactoryPlayer^.ShipmentType = ST_Manual) and (FactoryPlayer^.NowShipment < 0)) then Exit;
//ShowMessage('50');
  if ((Whole1Player^.ShipmentType  = ST_Manual) and (Whole1Player^.NowShipment  < 0)) then Exit;
//ShowMessage('51');
  if ((Whole2Player^.ShipmentType  = ST_Manual) and (Whole2Player^.NowShipment  < 0)) then Exit;
//ShowMessage('52');
  if ((RetailPlayer^.ShipmentType  = ST_Manual) and (RetailPlayer^.NowShipment  < 0)) then Exit;
//ShowMessage('53');
 // SIŏI^[ɂȂĂȂꍇ1^[i߂AłȂΏI
  Beep();
  if (FNowTurn < FFinalTurn) then ProcessTurn()
  else // I
  begin
    Result      := 1;
    FGameStatus := GS_Over;
    CountResult(FNowTurn - 1); // Ĩ^[1O܂łWv
  //Pause(); Xgbv͌Button_StopŌĂ
    Exit;
  end;
  Result := 0;
end;

//------------------------------------------------------------------------------
//-------------------------------- 1^[i߂ -------------------------------
procedure TBeerGame.ProcessTurn();
begin
  if (FNowTurn < 1) then Exit;
  if (FNowTurn >= FFinalTurn) then Exit;
 // Autȍꍇ͂Ŕ_2`6̊ԂŌ߂Ă
  if (FactoryPlayer^.PlayOwner = PO_Auto) then FactoryPlayer^.NowOrder := 2 + Random(4);
  if (Whole1Player^.PlayOwner  = PO_Auto) then Whole1Player^.NowOrder  := 2 + Random(4);
  if (Whole2Player^.PlayOwner  = PO_Auto) then Whole2Player^.NowOrder  := 2 + Random(4);
  if (RetailPlayer^.PlayOwner  = PO_Auto) then RetailPlayer^.NowOrder  := 2 + Random(4);

 {----------------- Ŋeȍ~ƁA܂͐Yxi߂ ----------------}
  Material_Lt1[NowTurn] := Factory_Ord [NowTurn - 1]; // Yx1
  Material_Lt2[NowTurn] := Material_Lt1[NowTurn - 1]; // Yx2

 {----------------------------------- H-------------------------------------}
 // H݌ɂɂ܂ו(Yx2)Z
  Factory_Stk [NowTurn] := Factory_Stk[NowTurn - 1] + Material_Lt2[NowTurn - 1];

 // zv̎wAAutoAll(Manual炢炸)
  if      (FactoryPlayer^.ShipmentType = ST_All)  then FactoryPlayer^.NowShipment := Whole1_Ord2[NowTurn - 1] + Factory_BLC[NowTurn - 1]
  else if (FactoryPlayer^.ShipmentType = ST_Auto) then FactoryPlayer^.NowShipment := 2 + Random(4);

 // zv > ݌ɂ̎͂邾AĎcT̎󒍎c
  if (Factory_Stk[NowTurn] < FactoryPlayer^.NowShipment) then
  begin
    Factory_Lt1[NowTurn] := Factory_Stk[NowTurn];
    Factory_BLC[NowTurn] := FactoryPlayer^.NowShipment - Factory_Stk[NowTurn];
  end
 // ݌ɂ͑ĂāAzv < ͎̎c󒍎c
  else if (FactoryPlayer^.NowShipment < Whole1_Ord2[NowTurn - 1]) then
  begin
    Factory_Lt1[NowTurn] := FactoryPlayer^.NowShipment;
    Factory_BLC[NowTurn] := Whole1_Ord2[NowTurn - 1] - FactoryPlayer^.NowShipment;
  end
 // (zv >= ł)Azv <= ݌ɂ̎́Az͂̂܂
  else
    Factory_Lt1[NowTurn] := FactoryPlayer^.NowShipment;

 // ۂɔč݌ɂ𔭑炷
  Factory_Stk  [NowTurn] := Factory_Stk[NowTurn] - Factory_Lt1[NowTurn];
  Factory_Lt2  [NowTurn] := Factory_Lt1[NowTurn - 1]; // zx2(Hꂩ)


 {----------------------------------- 1 -----------------------------------}
 // ꎟ݌ɂɂ܂ו(zx2(H))Z
  Whole1_Stk  [NowTurn] := Whole1_Stk[NowTurn - 1] + Factory_Lt2[NowTurn - 1];

 // zv̎wAAutoAll(Manual炢炸)
  if      (Whole1Player^.ShipmentType  = ST_All)  then Whole1Player^.NowShipment  := Whole2_Ord2[NowTurn - 1] + Whole1_BLC[NowTurn - 1]
  else if (Whole1Player^.ShipmentType  = ST_Auto) then Whole1Player^.NowShipment  := 2 + Random(4);

 // zv > ݌ɂ̎͂邾AĎcT̎󒍎c
  if (Whole1_Stk[NowTurn] < Whole1Player^.NowShipment) then
  begin
    Whole1_Lt1[NowTurn] := Whole1_Stk[NowTurn];
    Whole1_BLC[NowTurn] := Whole1Player^.NowShipment - Whole1_Stk[NowTurn];
  end
 // ݌ɂ͑ĂāAzv < ͎̎c󒍎c
  else if (Whole1Player^.NowShipment < Whole2_Ord2[NowTurn - 1]) then
  begin
    Whole1_Lt1[NowTurn] := Whole1Player^.NowShipment;
    Whole1_BLC[NowTurn] := Whole2_Ord2[NowTurn - 1] - Whole1Player^.NowShipment;
  end
 // (zv >= ł)Azv <= ݌ɂ̎́Az͂̂܂
  else
    Whole1_Lt1[NowTurn] := Whole1Player^.NowShipment;

 // ۂɔč݌ɂ𔭑炷
  Whole1_Stk  [NowTurn] := Whole1_Stk[NowTurn] - Whole1_Lt1[NowTurn];
  Whole1_Lt2  [NowTurn] := Whole1_Lt1[NowTurn - 1]; // zx2(1)

 {----------------------------------- 2 -----------------------------------}
 // 񎟉݌ɂɂ܂ו(zx2(ꎟ))Z
  Whole2_Stk  [NowTurn] := Whole2_Stk[NowTurn - 1] + Whole1_Lt2[NowTurn - 1];

 // zv̎wAAutoAll(Manual炢炸)
  if      (Whole2Player^.ShipmentType  = ST_All)  then Whole2Player^.NowShipment  := Retail_Ord2[NowTurn - 1] + Whole2_BLC[NowTurn - 1]
  else if (Whole2Player^.ShipmentType  = ST_Auto) then Whole2Player^.NowShipment  := 2 + Random(4);

 // zv > ݌ɂ̎͂邾AĎcT̎󒍎c
  if (Whole2_Stk[NowTurn] < Whole2Player^.NowShipment) then
  begin
    Whole2_Lt1[NowTurn] := Whole2_Stk[NowTurn];
    Whole2_BLC[NowTurn] := Whole2Player^.NowShipment - Whole2_Stk[NowTurn];
  end
 // ݌ɂ͑ĂāAzv < ͎̎c󒍎c
  else if (Whole2Player^.NowShipment < Retail_Ord2[NowTurn - 1]) then
  begin
    Whole2_Lt1[NowTurn] := Whole2Player^.NowShipment;
    Whole2_BLC[NowTurn] := Retail_Ord2[NowTurn - 1] - Whole2Player^.NowShipment;
  end
 // (zv >= ł)Azv <= ݌ɂ̎́Az͂̂܂
  else
    Whole2_Lt1[NowTurn] := Whole2Player^.NowShipment;

 // ۂɔč݌ɂ𔭑炷
  Whole2_Stk  [NowTurn] := Whole2_Stk[NowTurn] - Whole2_Lt1[NowTurn];
  Whole2_Lt2  [NowTurn] := Whole2_Lt1[NowTurn - 1]; // zx2(2)

 {---------------------------------- X -----------------------------------}
 // X݌ɂɂ܂ו(zx2(񎟉))Z
  Retail_Stk  [NowTurn] := Retail_Stk[NowTurn - 1] + Whole2_Lt2[NowTurn - 1];

 // zv̎wAAutoAll(Manual炢炸)
  if      (RetailPlayer^.ShipmentType  = ST_All)  then RetailPlayer^.NowShipment := Marcket_Ord[NowTurn - 1] + Retail_BLC[NowTurn - 1]
  else if (RetailPlayer^.ShipmentType  = ST_Auto) then RetailPlayer^.NowShipment := 2 + Random(4);

 // zv > ݌ɂ̎͂邾AĎcT̎󒍎c
  if (Retail_Stk[NowTurn] < RetailPlayer^.NowShipment) then
  begin
    Marcket_Sld[NowTurn] := Retail_Stk[NowTurn];
    Retail_BLC [NowTurn] := RetailPlayer^.NowShipment - Retail_Stk[NowTurn];
  end
 // ݌ɂ͑ĂāAzv < ͎̎c󒍎c
  else if (RetailPlayer^.NowShipment < Marcket_Ord[NowTurn - 1]) then
  begin
    Marcket_Sld[NowTurn] := RetailPlayer^.NowShipment;
    Retail_BLC [NowTurn] := Marcket_Ord[NowTurn - 1] - RetailPlayer^.NowShipment;
  end
 // (zv >= ł)Azv <= ݌ɂ̎́Az͂̂܂
  else
    Marcket_Sld[NowTurn] := RetailPlayer^.NowShipment;

 // ۂɔč݌ɂ𔭑炷
  Retail_Stk  [NowTurn] := Retail_Stk [NowTurn] - Marcket_Sld[NowTurn];// s֔̔

 {---------------------------------  ----------------------------------}
  Retail_Ord1 [NowTurn] := RetailPlayer^.NowOrder;   // X񎟉ւ̔
  Retail_Ord2 [NowTurn] := Retail_Ord1[NowTurn - 1]; // X񎟉ւ̒
  Whole2_Ord1 [NowTurn] := Whole2Player^.NowOrder;   // 񎟉ꎟւ̔
  Whole2_Ord2 [NowTurn] := Whole2_Ord1[NowTurn - 1]; // 񎟉ꎟւ̒
  Whole1_Ord1 [NowTurn] := Whole1Player^.NowOrder;   // ꎟHւ̔
  Whole1_Ord2 [NowTurn] := Whole1_Ord1[NowTurn - 1]; // ꎟHւ̒
  Factory_Ord [NowTurn] := FactoryPlayer^.NowOrder;  // Hꂩ猴ޗւ̐Yv

 {-------------------------------- RXgvZ ---------------------------------}
  StockCosts  [NowTurn] := (Factory_Stk[NowTurn] + Whole1_Stk  [NowTurn] + Whole2_Stk[NowTurn] + Retail_Stk[NowTurn]) * UStockCost;
  BackLogCosts[NowTurn] := (Factory_BLC[NowTurn] + Whole1_BLC  [NowTurn] + Whole2_BLC[NowTurn] + Retail_BLC[NowTurn]) * UBackLogCost;
  TotalCosts  [NowTurn] :=  StockCosts [NowTurn] + BackLogCosts[NowTurn];

 {-----------------------------------------------------------------------------}
 // 󂯎M
  FactoryPlayer^.NowOrder    := -1;
  Whole1Player^.NowOrder     := -1;
  Whole2Player^.NowOrder     := -1;
  RetailPlayer^.NowOrder     := -1;
  FactoryPlayer^.NowShipment := -1;
  Whole1Player^.NowShipment  := -1;
  Whole2Player^.NowShipment  := -1;
  RetailPlayer^.NowShipment  := -1;
 // ^[1₷
  Inc(FNowTurn);
//ShowMessage(IntToStr(FNowTurn) + ' / ' + IntToStr(FFinalTurn));
 // ŏI^[xInputUI
  if (FNowTurn >= FFinalTurn) then
  begin
    if ((FactoryPlayer <> Nil) and (FactoryPlayer^.PlayOwner = PO_Server)) then FactoryPlayer^.NowOrder    := 0;
    if ((Whole1Player  <> Nil) and (Whole1Player^.PlayOwner  = PO_Server)) then Whole1Player^.NowOrder     := 0;
    if ((Whole2Player  <> Nil) and (Whole2Player^.PlayOwner  = PO_Server)) then Whole2Player^.NowOrder     := 0;
    if ((RetailPlayer  <> Nil) and (RetailPlayer^.PlayOwner  = PO_Server)) then RetailPlayer^.NowOrder     := 0;
    if ((FactoryPlayer <> Nil) and (FactoryPlayer^.PlayOwner = PO_Server)) then FactoryPlayer^.NowShipment := 0;
    if ((Whole1Player  <> Nil) and (Whole1Player^.PlayOwner  = PO_Server)) then Whole1Player^.NowShipment  := 0;
    if ((Whole2Player  <> Nil) and (Whole2Player^.PlayOwner  = PO_Server)) then Whole2Player^.NowShipment  := 0;
    if ((RetailPlayer  <> Nil) and (RetailPlayer^.PlayOwner  = PO_Server)) then RetailPlayer^.NowShipment  := 0;
    PostMessage(FParentHandle , WM_InputCheck , 0 , 0);
  end;
 // 肪NCAgڑȂ^[e팻lbZ[WM
  SendClientStatus();
end;

//------------------------------------------------------------------------------
//------------------- ܂ł̗݌vRXgEύ݌ɓvZ ---------------------
procedure TBeerGame.CountResult(const CountTurn : ShortInt);
 var
  i : Integer;
begin
 // vl̊x
  FStockCost   := 0;
  FBackLogCost := 0;
  FTotalCost   := 0;
  FFt_Ave_Stk  := 0;
  FFt_Ave_BLC  := 0;
  FW1_Ave_Stk  := 0;
  FW1_Ave_BLC  := 0;
  FW2_Ave_Stk  := 0;
  FW2_Ave_BLC  := 0;
  FRt_Ave_Stk  := 0;
  FRt_Ave_BLC  := 0;
  if (CountTurn < 0) then Exit;
  for i := 0 to CountTurn do
  begin
    FStockCost   := FStockCost   + StockCosts[i];
    FBackLogCost := FBackLogCost + BackLogCosts[i];
    FTotalCost   := FTotalCost   + TotalCosts[i];
    FFt_Ave_Stk  := FFt_Ave_Stk  + Factory_Stk[i];
    FFt_Ave_BLC  := FFt_Ave_BLC  + Factory_BLC[i];
    FW1_Ave_Stk  := FW1_Ave_Stk  + Whole1_Stk[i];
    FW1_Ave_BLC  := FW1_Ave_BLC  + Whole1_BLC[i];
    FW2_Ave_Stk  := FW2_Ave_Stk  + Whole2_Stk[i];
    FW2_Ave_BLC  := FW2_Ave_BLC  + Whole2_BLC[i];
    FRt_Ave_Stk  := FRt_Ave_Stk  + Retail_Stk[i];
    FRt_Ave_BLC  := FRt_Ave_BLC  + Retail_BLC[i];
  end;
  FFt_Ave_Stk  := FFt_Ave_Stk / (CountTurn + 1); // 0TڂȂ̂Ŋ鐔͋tA؎Z
  FFt_Ave_BLC  := FFt_Ave_BLC / (CountTurn + 1);
  FW1_Ave_Stk  := FW1_Ave_Stk / (CountTurn + 1);
  FW1_Ave_BLC  := FW1_Ave_BLC / (CountTurn + 1);
  FW2_Ave_Stk  := FW2_Ave_Stk / (CountTurn + 1);
  FW2_Ave_BLC  := FW2_Ave_BLC / (CountTurn + 1);
  FRt_Ave_Stk  := FRt_Ave_Stk / (CountTurn + 1);
  FRt_Ave_BLC  := FRt_Ave_BLC / (CountTurn + 1);
end;

//------------------------------------------------------------------------------
//--------- 肪NCAgڑȂ^[e팻lbZ[WM ----------
procedure TBeerGame.SendClientStatus();
 var
  SendTurnMsg : String;
 //------NCAg֌݂̂̏ԑM
 procedure SendStatus(Socket : TCustomWinSocket);
 begin
   if ((Socket = Nil) or (not Socket.Connected)) then Exit;
   Socket.SendText(SendTurnMsg + SrcDivChar);
   Socket.SendText('BS_Ft:' + IntToHex(Factory_Stk[FNowTurn - 1] , 2) + SrcDivChar);
   Socket.SendText('BS_W1:' + IntToHex(Whole1_Stk [FNowTurn - 1] , 2) + SrcDivChar);
   Socket.SendText('BS_W2:' + IntToHex(Whole2_Stk [FNowTurn - 1] , 2) + SrcDivChar);
   Socket.SendText('BS_Rt:' + IntToHex(Retail_Stk [FNowTurn - 1] , 2) + SrcDivChar);
   //Socket.SendText('BS_Dm:' + IntToHex(Whole1_Ord2[FNowTurn - 1] , 2) + SrcDivChar);
   //Socket.SendText('BS_BC:' + IntToHex(Factory_BLC[FNowTurn - 1] , 2) + SrcDivChar);
  //---040825--Add
   if (FactoryPlayer^.PlayOwner = PO_Client) then
    Socket.SendText('BS_Dm0:' + IntToHex(Whole1_Ord2[FNowTurn - 1] , 2) + SrcDivChar);
    Socket.SendText('BS_BC0:' + IntToHex(Factory_BLC[FNowTurn - 1] , 2) + SrcDivChar);
  //  SendStatus(FactoryPlayer^.Socket);
   if (Whole1Player^.PlayOwner  = PO_Client) then
    Socket.SendText('BS_Dm1:' + IntToHex(Whole2_Ord2[FNowTurn - 1] , 2) + SrcDivChar);
    Socket.SendText('BS_BC1:' + IntToHex(Whole1_BLC[FNowTurn - 1] , 2) + SrcDivChar);
  //  SendStatus(Whole1Player^.Socket);
   if (Whole2Player^.PlayOwner  = PO_Client) then
    Socket.SendText('BS_Dm2:' + IntToHex(Retail_Ord2[FNowTurn - 1] , 2) + SrcDivChar);
    Socket.SendText('BS_BC2:' + IntToHex(Whole2_BLC[FNowTurn - 1] , 2) + SrcDivChar);
  //  SendStatus(Whole2Player^.Socket);
   if (RetailPlayer^.PlayOwner  = PO_Client) then
    Socket.SendText('BS_Dm3:' + IntToHex(Marcket_Ord[FNowTurn - 1] , 2) + SrcDivChar);
    Socket.SendText('BS_BC3:' + IntToHex(Retail_BLC[FNowTurn - 1] , 2) + SrcDivChar);
  //  SendStatus(RetailPlayer^.Socket);
  //-----------

 end;
begin
 // ^[^[bZ[W
  if (FNowTurn < FFinalTurn) then
    SendTurnMsg := 'BS_Tn:' + IntToHex(FNowTurn , 2)
  else
  begin
    SendTurnMsg := 'BS_Tn:Fn';  // Iʒm
{
    FactoryPlayer^.NowOrder    := 0;
    Whole1Player^.NowOrder     := 0;
    Whole2Player^.NowOrder     := 0;
    RetailPlayer^.NowOrder     := 0;
    FactoryPlayer^.NowShipment := 0;
    Whole1Player^.NowShipment  := 0;
    Whole2Player^.NowShipment  := 0;
    RetailPlayer^.NowShipment  := 0;
    PostMessage(FParentHandle , WM_InputCheck , 0 , 0);
}
  end;
 // eNCAg֑M    ---040825---update
  if (FactoryPlayer^.PlayOwner = PO_Client) then
    SendStatus(FactoryPlayer^.Socket);
  if (Whole1Player^.PlayOwner  = PO_Client) then
    SendStatus(Whole1Player^.Socket);
  if (Whole2Player^.PlayOwner  = PO_Client) then
    SendStatus(Whole2Player^.Socket);
  if (RetailPlayer^.PlayOwner  = PO_Client) then
    SendStatus(RetailPlayer^.Socket);
end;

//------------------------------------------------------------------------------
//---------------------------- ʃbZ[W ------------------------------
function TBeerGame.ResultMessage() : String;
 var
  ResultMsg : TStringList;
begin
  Result    := '';
  ResultMsg := TStringList.Create();
  try
  try
    ResultMsg.Add('*Result of [' + GroupName + ']*');
    ResultMsg.Add('');
    ResultMsg.Add('@ ' + FormatDateTime('(dd/mm/yyyy hh:nn:ss)' , Now()) + ' ');
    ResultMsg.Add('');
    ResultMsg.Add('------   Group    ------');
    ResultMsg.Add('Week      @@@      : ' + CurrToStr(FNowTurn - 1) + ' ');
    ResultMsg.Add('Unitcost of Inventory : ' + CurrToStr(UStockCost) + ' ');
    ResultMsg.Add('Unitcost of Backlog@ : ' + CurrToStr(UBackLogCost) + ' ');
    ResultMsg.Add('Total Inventory Cost  : ' + CurrToStr(FStockCost) + ' ');
    ResultMsg.Add('Total Backlog Cost  @: ' + CurrToStr(FBackLogCost) + ' ');
    ResultMsg.Add('Total Cost        @@: ' + CurrToStr(FTotalCost) + ' ');
    ResultMsg.Add('------ Eachmember ------');
    ResultMsg.Add('Average Inventory of Factory     : ' + CurrToStr(FFt_Ave_Stk) + ' ');
    ResultMsg.Add('Average Backlog of Factory       : ' + CurrToStr(FFt_Ave_BLC) + ' ');
    ResultMsg.Add('Average Inventory of Distributor : ' + CurrToStr(FW1_Ave_Stk) + ' ');
    ResultMsg.Add('Average Backlog of Distributor   : ' + CurrToStr(FW1_Ave_BLC) + ' ');
    ResultMsg.Add('Average Inventory of Wholesaler  : ' + CurrToStr(FW2_Ave_Stk) + ' ');
    ResultMsg.Add('Average Backlog of Wholesaler    : ' + CurrToStr(FW2_Ave_BLC) + ' ');
    ResultMsg.Add('Average Inventory of Retailer    : ' + CurrToStr(FRt_Ave_Stk) + ' ');
    ResultMsg.Add('Average Backlog of Retailer      : ' + CurrToStr(FRt_Ave_BLC) + ' ');
    Result := Trim(ResultMsg.Text);
  finally
    ResultMsg.Free();
  end
  except
  //raise;
  end;
end;

//------------------------------------------------------------------------------
//------------------------- Ŝ߂̕M -------------------------------
procedure TBeerGame.SendText(const Socket : TCustomWinSocket; const SendText : String; const UnitLength : Byte; const DivChar : Char);
 var
  NowUnitLength     : Byte;
  i , NowPos        : Integer;
  UnitStr , LineStr : String;
  StrList           : TStringList;
begin
  if (Socket = Nil)   then Exit;
  if (UnitLength = 0) then Exit;
  StrList := TStringList.Create();
  try
  try
    StrList.Text := SendText;
    if (StrList.Count < 1) then Exit;
   // 1sM
    for i := 0 to StrList.Count - 1 do
    begin
      NowPos := 1;
     // wPʂ̕M
      while (NowPos < Length(StrList.Strings[i])) do
      begin
        LineStr := StrList.Strings[i];
        NowUnitLength := UnitLength; // Ƃ肠{MPʒ

       // ̍s̎c̒MPʂZ瑗MPʂsb^c̕ɂB
        if ((Length(LineStr) - (NowPos - 1)) < NowUnitLength) then
          NowUnitLength := Length(LineStr) - (NowPos - 1);

       // ]Pʂ̍Ō̕Sp̑O1Byteꍇ͓]Pʂ1Byte炷
        if ( ByteType(LineStr , (NowPos + NowUnitLength - 1)) = mbLeadByte) then Dec(NowUnitLength);
       // ]̐؏oƓ]
        UnitStr := Copy(StrList.Strings[i] , NowPos , NowUnitLength);
        Socket.SendText(UnitStr);
        Inc(NowPos , NowUnitLength); // |WVi߂
      end;
     // sɉsR[ht
      Socket.SendText(#13); // #1310?ɂȂĂ܂̂
    end;
   // Ōɂ͏IR[ht
    Socket.SendText(DivChar);
  finally
    StrList.Free();
  end
  except
  //raise;
  end;
end;


//------------------------------------------------------------------------------
//-------------------------- CX^X ----------------------------------
procedure TBeerGame.Assign(Source : TPersistent);
 var
  MS : TMemoryStream;
begin
  if      (Source = Nil) then Initialize()
  else if (Source is TBeerGame) then
  begin
    MS := TMemoryStream.Create();
    try
    try
      (Source as TBeerGame).SaveToStream(MS);
      LoadFromStream(MS);
    finally
      MS.Free();
    end
    except

    end;
  end
  else inherited Assign(Source);
end;

//------------------------------------------------------------------------------
//--------------------------- Q[f[^Ǎ ---------------------------------
procedure TBeerGame.LoadFromStream(Stream : TStream);
 const
  Header = 'Kun''s_Beer_Game!';
 var
  i     : Integer;
  MS    : TMemoryStream;
  MSBk  : TMemoryStream;
  Buf   : array of Char;
  Len   : Integer;
  FtSoc : TCustomWinSocket;
  W1Soc : TCustomWinSocket;
  W2Soc : TCustomWinSocket;
  RtSoc : TCustomWinSocket;
begin
  if (FGameStatus = GS_Playing) then Exit;
  if (Stream = Nil) then Exit;
  MS   := TMemoryStream.Create();
  MSBk := TMemoryStream.Create();
  try
  try
   // ̃obNAbv
    SaveToStream(MSBk);
   // ǂݍ݊Jn
    MS.LoadFromStream(Stream); // StreamMSցǍMSf[^
    if (MS.Size < 110) then Exit;
   // Size Check
    MS.Seek(-SizeOf(Integer) , soFromEnd);
    MS.ReadBuffer(Len , SizeOf(Integer));
    if (Len <> MS.Size) then
    begin
      Beep();
      MessageDlg('Data Sum Error' , mtError , [mbOK] , 0);
  //06/02/15    Application.MessageBox('Data Sum Error' , 'Error' , mb_OK);
      Exit;
    end;
    MS.Seek(0 , soFromBeginning);
   // Header Check
    SetLength(Buf , Length(Header));
    MS.ReadBuffer(Buf[0] , Length(Header));
    if (AnsiCompareStr(String(Buf) , Header) <> 0) then Exit;
   // Q[
    MS.ReadBuffer(FNowTurn     , SizeOf(FNowTurn));
    MS.ReadBuffer(FFinalTurn   , SizeOf(FFinalTurn));
    MS.ReadBuffer(FGameStatus  , SizeOf(FGameStatus));
   // z̃TCYm
    SetFinalTurn(FFinalTurn);
    Initialize();
   // vp
    MS.ReadBuffer(FStockCost   , SizeOf(FStockCost));
    MS.ReadBuffer(FBackLogCost , SizeOf(FBackLogCost));
    MS.ReadBuffer(FTotalCost   , SizeOf(FTotalCost));
   // e핽ϒl
    MS.ReadBuffer(FFt_Ave_Stk , SizeOf(FFt_Ave_Stk));
    MS.ReadBuffer(FFt_Ave_BLC , SizeOf(FFt_Ave_BLC));
    MS.ReadBuffer(FW1_Ave_Stk , SizeOf(FW1_Ave_Stk));
    MS.ReadBuffer(FW1_Ave_BLC , SizeOf(FW1_Ave_BLC));
    MS.ReadBuffer(FW2_Ave_Stk , SizeOf(FW2_Ave_Stk));
    MS.ReadBuffer(FW2_Ave_BLC , SizeOf(FW2_Ave_BLC));
    MS.ReadBuffer(FRt_Ave_Stk , SizeOf(FRt_Ave_Stk));
    MS.ReadBuffer(FRt_Ave_BLC , SizeOf(FRt_Ave_BLC));
   // O[v
    MS.ReadBuffer(Len , SizeOf(Integer));
    SetLength(Buf , Len);
    MS.ReadBuffer(Buf[0] , Len);
    GroupName := String(Buf);
   // v[[f[^(Socket̂݃obNAbv)
    FtSoc := Factory_AutoP.Socket;
    W1Soc := Whole1_AutoP.Socket;
    W2Soc := Whole2_AutoP.Socket;
    RtSoc := Retail_AutoP.Socket;
   // v[[f[^Ǎ
    MS.ReadBuffer(Factory_AutoP , SizeOf(TPlayerData));
    MS.ReadBuffer(Whole1_AutoP  , SizeOf(TPlayerData));
    MS.ReadBuffer(Whole2_AutoP  , SizeOf(TPlayerData));
    MS.ReadBuffer(Retail_AutoP  , SizeOf(TPlayerData));
    Factory_AutoP.Socket := FtSoc;
    Whole1_AutoP.Socket  := W1Soc;
    Whole2_AutoP.Socket  := W2Soc;
    Retail_AutoP.Socket  := RtSoc;
    MS.ReadBuffer(Len , SizeOf(Integer));
    SetLength(Buf , Len);
    MS.ReadBuffer(Buf[0] , Len);
{TPlayerDataƓǂݍł܂Ă邽߁AStringp̃|C^ł̂GetMem}
    GetMem(Pointer(Factory_AutoP.PlayerName) , SizeOf(Pointer));
    GetMem(Pointer(Whole1_AutoP.PlayerName)  , SizeOf(Pointer));
    GetMem(Pointer(Whole2_AutoP.PlayerName)  , SizeOf(Pointer));
    GetMem(Pointer(Retail_AutoP.PlayerName)  , SizeOf(Pointer));
{v[l[}
    Factory_AutoP.PlayerName := 'Factory(server operation)';
    Factory_AutoP.PlayerName := String(Buf);
    MS.ReadBuffer(Len , SizeOf(Integer));
    SetLength(Buf , Len);
    MS.ReadBuffer(Buf[0] , Len);
    Whole1_AutoP.PlayerName := 'Distributor(server operation)';
    Whole1_AutoP.PlayerName := String(Buf);
    MS.ReadBuffer(Len , SizeOf(Integer));
    SetLength(Buf , Len);
    MS.ReadBuffer(Buf[0] , Len);
    Whole2_AutoP.PlayerName := 'Wholesaler(server operation)';
    Whole2_AutoP.PlayerName := String(Buf);
    MS.ReadBuffer(Len , SizeOf(Integer));
    SetLength(Buf , Len);
    MS.ReadBuffer(Buf[0] , Len);
    Retail_AutoP.PlayerName := 'Retailer(server operation)';
    Retail_AutoP.PlayerName := String(Buf);
   // ݌
    MS.ReadBuffer(Material_Lt1[0] , SizeOf(Byte) * Length(Material_Lt1));
    MS.ReadBuffer(Material_Lt2[0] , SizeOf(Byte) * Length(Material_Lt2));
    MS.ReadBuffer(Factory_Stk[0]  , SizeOf(Byte) * Length(Factory_Stk));
    MS.ReadBuffer(Factory_BLC[0]  , SizeOf(Byte) * Length(Factory_BLC));
    MS.ReadBuffer(Factory_Lt1[0]  , SizeOf(Byte) * Length(Factory_Lt1));
    MS.ReadBuffer(Factory_Lt2[0]  , SizeOf(Byte) * Length(Factory_Lt2));
    MS.ReadBuffer(Whole1_Stk[0]   , SizeOf(Byte) * Length(Whole1_Stk));
    MS.ReadBuffer(Whole1_BLC[0]   , SizeOf(Byte) * Length(Whole1_BLC));
    MS.ReadBuffer(Whole1_Lt1[0]   , SizeOf(Byte) * Length(Whole1_Lt1));
    MS.ReadBuffer(Whole1_Lt2[0]   , SizeOf(Byte) * Length(Whole1_Lt2));
    MS.ReadBuffer(Whole2_Stk[0]   , SizeOf(Byte) * Length(Whole2_Stk));
    MS.ReadBuffer(Whole2_BLC[0]   , SizeOf(Byte) * Length(Whole2_BLC));
    MS.ReadBuffer(Whole2_Lt1[0]   , SizeOf(Byte) * Length(Whole2_Lt1));
    MS.ReadBuffer(Whole2_Lt2[0]   , SizeOf(Byte) * Length(Whole2_Lt2));
    MS.ReadBuffer(Retail_Stk[0]   , SizeOf(Byte) * Length(Retail_Stk));
    MS.ReadBuffer(Retail_BLC[0]   , SizeOf(Byte) * Length(Retail_BLC));
   // 
    MS.ReadBuffer(Retail_Ord1[0] , SizeOf(Byte) * Length(Retail_Ord1));
    MS.ReadBuffer(Retail_Ord2[0] , SizeOf(Byte) * Length(Retail_Ord2));
    MS.ReadBuffer(Whole2_Ord1[0] , SizeOf(Byte) * Length(Whole2_Ord1));
    MS.ReadBuffer(Whole2_Ord2[0] , SizeOf(Byte) * Length(Whole2_Ord2));
    MS.ReadBuffer(Whole1_Ord1[0] , SizeOf(Byte) * Length(Whole1_Ord1));
    MS.ReadBuffer(Whole1_Ord2[0] , SizeOf(Byte) * Length(Whole1_Ord2));
    MS.ReadBuffer(Factory_Ord[0] , SizeOf(Byte) * Length(Factory_Ord));
   // sv̔
    MS.ReadBuffer(Marcket_Ord[0] , SizeOf(Byte) * Length(Marcket_Ord));
    MS.ReadBuffer(Marcket_Sld[0] , SizeOf(Byte) * Length(Marcket_Sld));
   // RXg
    MS.ReadBuffer(UStockCost      , SizeOf(UStockCost));
    MS.ReadBuffer(UBackLogCost    , SizeOf(UBackLogCost));
    MS.ReadBuffer(StockCosts[0]   , SizeOf(Currency) * Length(StockCosts));
    MS.ReadBuffer(BackLogCosts[0] , SizeOf(Currency) * Length(BackLogCosts));
    MS.ReadBuffer(TotalCosts[0]   , SizeOf(Currency) * Length(TotalCosts));
   // Q[(Q[̃[h͋֎~Ă邽)
    if (FGameStatus = GS_Playing) then FGameStatus := GS_Pause;
  except
    LoadFromStream(MSBk);
  end
  finally
    MSBk.Free();
    MS.Free();
  end;
end;

//------------------------------------------------------------------------------
//--------------------------- Q[f[^Ǎ ---------------------------------
procedure TBeerGame.LoadFromFile(const FilePath : String);
 var
  MS    : TMemoryStream;
begin
  if (FGameStatus = GS_Playing) then Exit;
  if (not FileExists(FilePath)) then Exit;
  MS := TMemoryStream.Create();
  try
  try
    MS.LoadFromFile(FilePath);
    LoadFromStream(MS);
    Beep();
    MessageDlg('Loadede.' , mtInformation , [mbOK] , 0);
  //06/02/15  Application.MessageBox('Loadede.' , 'Information' , mb_OK);
  finally
    MS.Free();
  end
  except
  end;
end;

//------------------------------------------------------------------------------
//--------------------------- Q[f[^ۑ ---------------------------------
procedure TBeerGame.SaveToStream(Stream : TStream);
 const
  Header = 'Nomadic_Computer_Network_Beer_Game!';
 var
  TmpInt : Integer;
  MS     : TMemoryStream;
begin
  if  (Stream = Nil) then Exit;
  MS := TMemoryStream.Create();
  try
  try
   // File Header
    MS.WriteBuffer(Header[1] , Length(Header));
   // Q[
    MS.WriteBuffer(FNowTurn     , SizeOf(FNowTurn));
    MS.WriteBuffer(FFinalTurn   , SizeOf(FFinalTurn));
    MS.WriteBuffer(FGameStatus  , SizeOf(FGameStatus));
   // vp
    MS.WriteBuffer(FStockCost   , SizeOf(FStockCost));
    MS.WriteBuffer(FBackLogCost , SizeOf(FBackLogCost));
    MS.WriteBuffer(FTotalCost   , SizeOf(FTotalCost));
   // e핽ϒl
    MS.WriteBuffer(FFt_Ave_Stk , SizeOf(FFt_Ave_Stk));
    MS.WriteBuffer(FFt_Ave_BLC , SizeOf(FFt_Ave_BLC));
    MS.WriteBuffer(FW1_Ave_Stk , SizeOf(FW1_Ave_Stk));
    MS.WriteBuffer(FW1_Ave_BLC , SizeOf(FW1_Ave_BLC));
    MS.WriteBuffer(FW2_Ave_Stk , SizeOf(FW2_Ave_Stk));
    MS.WriteBuffer(FW2_Ave_BLC , SizeOf(FW2_Ave_BLC));
    MS.WriteBuffer(FRt_Ave_Stk , SizeOf(FRt_Ave_Stk));
    MS.WriteBuffer(FRt_Ave_BLC , SizeOf(FRt_Ave_BLC));
   // O[v
    TmpInt := Length(GroupName);
    MS.WriteBuffer(TmpInt       , SizeOf(Integer));
    MS.WriteBuffer(GroupName[1] , Length(GroupName));
   // v[[f[^
    MS.WriteBuffer(Factory_AutoP , SizeOf(TPlayerData));
    MS.WriteBuffer(Whole1_AutoP  , SizeOf(TPlayerData));
    MS.WriteBuffer(Whole2_AutoP  , SizeOf(TPlayerData));
    MS.WriteBuffer(Retail_AutoP  , SizeOf(TPlayerData));
   // v[[
    TmpInt := Length(Factory_AutoP.PlayerName);
    MS.WriteBuffer(TmpInt                      , SizeOf(Integer));
    MS.WriteBuffer(Factory_AutoP.PlayerName[1] , Length(Factory_AutoP.PlayerName));
    TmpInt := Length(Whole1_AutoP.PlayerName);
    MS.WriteBuffer(TmpInt                      , SizeOf(Integer));
    MS.WriteBuffer(Whole1_AutoP.PlayerName[1]  , Length(Whole1_AutoP.PlayerName));
    TmpInt := Length(Whole2_AutoP.PlayerName);
    MS.WriteBuffer(TmpInt                      , SizeOf(Integer));
    MS.WriteBuffer(Whole2_AutoP.PlayerName[1]  , Length(Whole2_AutoP.PlayerName));
    TmpInt := Length(Retail_AutoP.PlayerName);
    MS.WriteBuffer(TmpInt                      , SizeOf(Integer));
    MS.WriteBuffer(Retail_AutoP.PlayerName[1]  , Length(Retail_AutoP.PlayerName));
   // ݌
    MS.WriteBuffer(Material_Lt1[0] , SizeOf(Byte) * Length(Material_Lt1));
    MS.WriteBuffer(Material_Lt2[0] , SizeOf(Byte) * Length(Material_Lt2));
    MS.WriteBuffer(Factory_Stk[0]  , SizeOf(Byte) * Length(Factory_Stk));
    MS.WriteBuffer(Factory_BLC[0]  , SizeOf(Byte) * Length(Factory_BLC));
    MS.WriteBuffer(Factory_Lt1[0]  , SizeOf(Byte) * Length(Factory_Lt1));
    MS.WriteBuffer(Factory_Lt2[0]  , SizeOf(Byte) * Length(Factory_Lt2));
    MS.WriteBuffer(Whole1_Stk[0]   , SizeOf(Byte) * Length(Whole1_Stk));
    MS.WriteBuffer(Whole1_BLC[0]   , SizeOf(Byte) * Length(Whole1_BLC));
    MS.WriteBuffer(Whole1_Lt1[0]   , SizeOf(Byte) * Length(Whole1_Lt1));
    MS.WriteBuffer(Whole1_Lt2[0]   , SizeOf(Byte) * Length(Whole1_Lt2));
    MS.WriteBuffer(Whole2_Stk[0]   , SizeOf(Byte) * Length(Whole2_Stk));
    MS.WriteBuffer(Whole2_BLC[0]   , SizeOf(Byte) * Length(Whole2_BLC));
    MS.WriteBuffer(Whole2_Lt1[0]   , SizeOf(Byte) * Length(Whole2_Lt1));
    MS.WriteBuffer(Whole2_Lt2[0]   , SizeOf(Byte) * Length(Whole2_Lt2));
    MS.WriteBuffer(Retail_Stk[0]   , SizeOf(Byte) * Length(Retail_Stk));
    MS.WriteBuffer(Retail_BLC[0]   , SizeOf(Byte) * Length(Retail_BLC));
   // 
    MS.WriteBuffer(Retail_Ord1[0] , SizeOf(Byte) * Length(Retail_Ord1));
    MS.WriteBuffer(Retail_Ord2[0] , SizeOf(Byte) * Length(Retail_Ord2));
    MS.WriteBuffer(Whole2_Ord1[0] , SizeOf(Byte) * Length(Whole2_Ord1));
    MS.WriteBuffer(Whole2_Ord2[0] , SizeOf(Byte) * Length(Whole2_Ord2));
    MS.WriteBuffer(Whole1_Ord1[0] , SizeOf(Byte) * Length(Whole1_Ord1));
    MS.WriteBuffer(Whole1_Ord2[0] , SizeOf(Byte) * Length(Whole1_Ord2));
    MS.WriteBuffer(Factory_Ord[0] , SizeOf(Byte) * Length(Factory_Ord));
   // sv̔
    MS.WriteBuffer(Marcket_Ord[0] , SizeOf(Byte) * Length(Marcket_Ord));
    MS.WriteBuffer(Marcket_Sld[0] , SizeOf(Byte) * Length(Marcket_Sld));
   // RXg
    MS.WriteBuffer(UStockCost      , SizeOf(UStockCost));
    MS.WriteBuffer(UBackLogCost    , SizeOf(UBackLogCost));
    MS.WriteBuffer(StockCosts[0]   , SizeOf(Currency) * Length(StockCosts));
    MS.WriteBuffer(BackLogCosts[0] , SizeOf(Currency) * Length(BackLogCosts));
    MS.WriteBuffer(TotalCosts[0]   , SizeOf(Currency) * Length(TotalCosts));
   // ŌɃTCYt
    TmpInt := MS.Size + SizeOf(Integer);
    MS.WriteBuffer(TmpInt , SizeOf(Integer));
   // 
    MS.SaveToStream(Stream);
  finally
    MS.Free();
  end
  except
    Beep();
    MessageDlg('Stream output error!' , mtError , [mbOK] , 0);
  //06/02/15  Application.MessageBox('Stream output error!' , 'Error' , mb_OK);
  end;
end;

//------------------------------------------------------------------------------
//--------------------------- Q[f[^ۑ ---------------------------------
procedure TBeerGame.SaveToFile(const FilePath : String);
 var
  MS     : TMemoryStream;
begin
  MS := TMemoryStream.Create();
  try
  try
    SaveToStream(MS);
   // 
    MS.SaveToFile(FilePath);
    Beep();
    MessageDlg('Saved.' , mtInformation , [mbOK] , 0);
  //06/02/15  Application.MessageBox('Saved.' , 'Information' , mb_OK);
  finally
    MS.Free();
  end
  except
    Beep();
    MessageDlg('File writing error.' , mtError , [mbOK] , 0);
  //06/02/15  Application.MessageBox('File writing error.' , 'Error' , mb_OK);
  end;
end;

//------------------------------------------------------------------------------
//------------------------------ ȈՈÍ ------------------------------------
function TBeerGame.EnDeCrypt(const Value : String) : String;
 var
  i : integer;
begin
  Result := Value;
  for i := 1 to Length(Value) do
    Result[i] := Chr(not (Ord(Value[i])));
end;

//------------------------------------------------------------------------------
end.
