unit PreviewS;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TBeerGameServerPreviewForm = class(TForm)
    Memo     : TMemo;
    TrackBar : TTrackBar;
    procedure FormCreate    (Sender : TObject);
    procedure TrackBarChange(Sender : TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form_Preview : TBeerGameServerPreviewForm;

implementation

uses
  ShellAPI , BS_Main;

{$R *.DFM}

//------------------------------------------------------------------------------
procedure TBeerGameServerPreviewForm.FormCreate(Sender : TObject);
 const
  WS_EX_LAYERED = $80000;
begin
  Self.Memo.Font.Assign(Form_Main.Font);
 // Window
  CBackProc := nil;
  DLLWnd    := LoadLibrary('User32.dll');
  if (DLLWnd > 0) then  // DLL̃[hꍇ
  begin
    CBackProc := GetProcAddress(DLLWnd , 'SetLayeredWindowAttributes');
    if (CBackProc <> nil) then // SetLayeredWindowAttributes APĨ[hꍇ
    begin
      @SetLayeredWindowAttributes := CBackProc;
    //SetWindowLong(Form_Main.Handle , GWL_EXSTYLE , GetWindowLong(Form_Main.Handle , GWL_EXSTYLE) + WS_EX_LAYERED);
      SetWindowLong(Handle           , GWL_EXSTYLE , GetWindowLong(Handle           , GWL_EXSTYLE) + WS_EX_LAYERED);
      TrackBarChange(Self);
    end
    else // API[hs̏ꍇAΉOS̏ꍇƂ
    begin
      TrackBar.Visible := False;
      TrackBar.Enabled := False;
      Memo.Align       := alClient;
    end;
  end;
  DragAcceptFiles(Form_Main.Handle , True);  // hbvtJn
end;

//------------------------------------------------------------------------------
procedure TBeerGameServerPreviewForm.TrackBarChange(Sender : TObject);
 const
  LWA_COLORKEY  = 1;
  LWA_ALPHA     = 2;
 var
  KeyColor : TColor;
begin
  if (CBackProc <> nil) then
  begin
    KeyColor := clBtnFace; // Ƃ肠A̍sɂƂ̐FߐFɂł
  //SetLayeredWindowAttributes(Form_Main.Handle , ColorToRGB(KeyColor) , TrackBar.Position , LWA_ALPHA);
    SetLayeredWindowAttributes(Handle           , ColorToRGB(KeyColor) , TrackBar.Position , LWA_ALPHA);
  //SetLayeredWindowAttributes(Form_Main.Handle , ColorToRGB(KeyColor) , TrackBar.Position , LWA_COLORKEY);
  end;
end;

//------------------------------------------------------------------------------
end.
